<template>
    <q-card-section class="fit r-parent" ref="parent">
        <q-resize-observer @resize="Resize"/>
        <div class="over" :style="Overline">
            {{ overline }}
        </div>
        <div class="main">
            <div class="real">
                <div :style="Value">
                    {{ V }}
                </div>
                <div class="under" :style="Unit">
                    {{ unit }}
                </div>
            </div>
            <q-separator vertical/>
            <div class="delta">
                <div :style="DeltaStyle">
                    <q-icon :name="Icon" :color="Color" :style="Value"/>
                    {{ Delta }}
                </div>
            </div>
        </div>
        <div>

        </div>
    </q-card-section>
</template>
<style lang='scss' scoped>

.real, .delta {
    padding: 0 10px;
}

.r-parent {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: space-between;
}

.over {
    font-family: Raleway, 'sans-serif';
    text-transform: uppercase;
}

.main {
    display: flex;
    justify-content: center;
    align-items: center;
    text-align: center;
}

.under {
    font-family: Raleway, 'sans-serif';
    text-transform: uppercase;
    text-align: center;
}
</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {MetricValue} from "src/classLibrary/Dashboard/SingeMetricQuery";
import {FormatDuration} from "src/classLibrary/Utility";

@Component
export default class RelativeMetricWidget extends Vue {
    @Prop() value!: MetricValue;
    @Prop() prev!: MetricValue;
    @Prop() overline!: string;
    @Prop() unit!: string;


    UnWrapRaw(m: MetricValue): number {
        return MetricValue.match(m, {
            Count(p0: number) {
                return p0;
            }, Duration(p0: number) {
                return p0;
            }
        })
    }

    get Icon() {

        const prev = this.UnWrapRaw(this.prev), now = this.UnWrapRaw(this.value);
        return prev > now ? 'south' : 'north';
    }

    get Color() {
        const prev = this.UnWrapRaw(this.prev), now = this.UnWrapRaw(this.value);
        return prev > now ? 'negative' : 'positive';
    }

    get Delta() {
        const prev = this.UnWrapRaw(this.prev), now = this.UnWrapRaw(this.value);
        const diff = now - prev;
        const perc = (diff / prev * 100).toFixed(2) + "%";
        return perc;

    }

    get V() {
        return MetricValue.match(this.value, {
            Count(p0: number) {
                return p0.toFixed(2).ToFloat().toLocaleString();
            }, Duration(seconds: number) {
                return FormatDuration({seconds}, true);
            }
        })
    }


    w: number = 200;
    h: number = 200;

    get Unit() {
        const fontSize = (this.w / 35) + "px";
        return {
            fontSize,
        }
    }

    get DeltaStyle() {
        const fontSize = (this.w / 30) + "px";
        return {
            fontSize,
        }
    }

    get Value() {
        const fontSize = (this.w / 15) + "px";
        return {
            fontSize,
        }
    }

    get Overline() {
        const fontSize = (this.w / 30) + "px";
        return {
            fontSize,
        }
    }

    Resize() {
        const parent = (this.$refs.parent as any).$el as HTMLElement;
        this.w = parent.getBoundingClientRect().width;
        this.h = parent.getBoundingClientRect().height;
    }
}
</script>

